Merge remote-tracking branch 'remotes/cohuck/tags/s390x-20190701' into staging
[qemu/ar7.git] / scripts / clean-includes
blobdd938daa3eccf900b43c7bcb93a87ff2fdf4e8bf
1 #!/bin/sh -e
3 # Clean up QEMU #include lines by ensuring that qemu/osdep.h
4 # is the first include listed in .c files, and no headers provided
5 # by osdep.h itself are redundantly included in either .c or .h files.
7 # Copyright (c) 2015 Linaro Limited
9 # Authors:
10 # Peter Maydell <peter.maydell@linaro.org>
12 # This work is licensed under the terms of the GNU GPL, version 2
13 # or (at your option) any later version. See the COPYING file in
14 # the top-level directory.
16 # Usage:
17 # clean-includes [--git subjectprefix] [--check-dup-head] file ...
18 # or
19 # clean-includes [--git subjectprefix] [--check-dup-head] --all
21 # If the --git subjectprefix option is given, then after making
22 # the changes to the files this script will create a git commit
23 # with the subject line "subjectprefix: Clean up includes"
24 # and a boilerplate commit message.
26 # If --check-dup-head is specified, additionally check for duplicate
27 # header includes.
29 # Using --all will cause clean-includes to run on the whole source
30 # tree (excluding certain directories which are known not to need
31 # handling).
33 # This script requires Coccinelle to be installed.
35 # .c files will have the osdep.h included added, and redundant
36 # includes removed.
37 # .h files will have redundant includes (including includes of osdep.h)
38 # removed.
39 # Other files (including C++ and ObjectiveC) can't be handled by this script.
41 # The following one-liner may be handy for finding files to run this on.
42 # However some caution is required regarding files that might be part
43 # of the guest agent or standalone tests.
45 # for i in $(git ls-tree --name-only HEAD) ; do test -f $i && \
46 # grep -E '^# *include' $i | head -1 | grep 'osdep.h' ; test $? != 0 && \
47 # echo $i ; done
50 GIT=no
51 DUPHEAD=no
53 # Extended regular expression defining files to ignore when using --all
54 XDIRREGEX='^(tests/tcg|tests/multiboot|pc-bios|disas/libvixl)'
56 while true
58 case $1 in
59 "--git")
60 if [ $# -eq 1 ]; then
61 echo "--git option requires an argument"
62 exit 1
64 GITSUBJ="$2"
65 GIT=yes
66 shift
67 shift
69 "--check-dup-head")
70 DUPHEAD=yes
71 shift
73 "--")
74 shift
75 break
78 break
80 esac
81 done
83 if [ $# -eq 0 ]; then
84 echo "Usage: clean-includes [--git subjectprefix] [--check-dup-head] [--all | foo.c ...]"
85 echo "(modifies the files in place)"
86 exit 1
89 if [ "$1" = "--all" ]; then
90 # We assume there are no files in the tree with spaces in their name
91 set -- $(git ls-files '*.[ch]' | grep -E -v "$XDIRREGEX")
94 # Annoyingly coccinelle won't read a scriptfile unless its
95 # name ends '.cocci', so write it out to a tempfile with the
96 # right kind of name.
97 COCCIFILE="$(mktemp --suffix=.cocci)"
99 trap 'rm -f -- "$COCCIFILE"' INT TERM HUP EXIT
101 cat >"$COCCIFILE" <<EOT
106 + #include "qemu/osdep.h"
107 #include "..."
109 + #include "qemu/osdep.h"
110 #include <...>
114 for f in "$@"; do
115 case "$f" in
116 *.inc.c)
117 # These aren't standalone C source files
118 echo "SKIPPING $f (not a standalone source file)"
119 continue
121 *.c)
122 MODE=c
124 *include/qemu/osdep.h | \
125 *include/qemu/compiler.h | \
126 *include/glib-compat.h | \
127 *include/sysemu/os-posix.h | \
128 *include/sysemu/os-win32.h | \
129 *include/standard-headers/ )
130 # Removing include lines from osdep.h itself would be counterproductive.
131 echo "SKIPPING $f (special case header)"
132 continue
134 *include/standard-headers/*)
135 echo "SKIPPING $f (autogenerated header)"
136 continue
138 *.h)
139 MODE=h
142 echo "WARNING: ignoring $f (cannot handle non-C files)"
143 continue
145 esac
147 if [ "$MODE" = "c" ]; then
148 # First, use Coccinelle to add qemu/osdep.h before the first existing include
149 # (this will add two lines if the file uses both "..." and <...> #includes,
150 # but we will remove the extras in the next step)
151 spatch --in-place --no-show-diff --cocci-file "$COCCIFILE" "$f"
153 # Now remove any duplicate osdep.h includes
154 perl -n -i -e 'print if !/#include "qemu\/osdep.h"/ || !$n++;' "$f"
155 else
156 # Remove includes of osdep.h itself
157 perl -n -i -e 'print if !/\s*#\s*include\s*(["<][^>"]*[">])/ ||
158 ! (grep { $_ eq $1 } qw ("qemu/osdep.h"))' "$f"
161 # Remove includes that osdep.h already provides
162 perl -n -i -e 'print if !/\s*#\s*include\s*(["<][^>"]*[">])/ ||
163 ! (grep { $_ eq $1 } qw (
164 "config-host.h" "config-target.h" "qemu/compiler.h"
165 <setjmp.h> <stdarg.h> <stddef.h> <stdbool.h> <stdint.h> <sys/types.h>
166 <stdlib.h> <stdio.h> <string.h> <strings.h> <inttypes.h>
167 <limits.h> <unistd.h> <time.h> <ctype.h> <errno.h> <fcntl.h>
168 <sys/stat.h> <sys/time.h> <assert.h> <signal.h> <glib.h>
169 <sys/stat.h> <sys/time.h> <assert.h> <signal.h> <glib.h> <sys/mman.h>
170 "sysemu/os-posix.h, sysemu/os-win32.h "glib-compat.h"
171 "qemu/typedefs.h"
172 ))' "$f"
174 done
176 if [ "$DUPHEAD" = "yes" ]; then
177 egrep "^[[:space:]]*#[[:space:]]*include" "$@" | tr -d '[:blank:]' \
178 | sort | uniq -c | awk '{if ($1 > 1) print $0}'
179 if [ $? -eq 0 ]; then
180 echo "Found duplicate header file includes. Please check the above files manually."
181 exit 1
185 if [ "$GIT" = "yes" ]; then
186 git add -- "$@"
187 git commit --signoff -F - <<EOF
188 $GITSUBJ: Clean up includes
190 Clean up includes so that osdep.h is included first and headers
191 which it implies are not included manually.
193 This commit was created with scripts/clean-includes.